/*****
 *                                                                   
 *                   Searduino
 *                      
 *   Copyright (C) 2011 Henrik Sandklef 
 *                                                                   
 * This program is free software; you can redistribute it and/or     
 * modify it under the terms of the GNU General Public License       
 * as published by the Free Software Foundation; either version 3    
 * of the License, or any later version.                             
 *                                                                   
 *                                                                   
 * This program is distributed in the hope that it will be useful,   
 * but WITHOUT ANY WARRANTY; without even the implied warranty of    
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     
 * GNU General Public License for more details.                      
 *                                                                   
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software       
 * Foundation, Inc., 51 Franklin Street, Boston,            
 * MA  02110-1301, USA.                                              
 ****/

#include <pthread.h>
#include "stdio.h"
#include "string.h"
#include "unistd.h"

#include "utils/include/types.h"
#include "utils/include/print.h"

#include "../include/comm.h"
#include "../include/error.h"



/*
 *
 * File descriptor to use for all proto printouts
 *
 */
static FILE* proto_stream ;
static int   init;

#define init_proto() if (!init) {init_proto_impl();}

di_callback_ptr di_callback;

void* command_reader(void* in)
{
  char buf[100];
  char *tmp;
  int  pin;
  int  val;

  printf ("COMMAND READER begins\n");
    
  for (;;)
    {
/*       printf ("COMMAND READER reads\n"); */
      fgets(buf, 100, stdin);
/*       printf ("Just read: '%s'\n", buf);  */
      
      if (strncmp(buf,"pin:",4)==0)
	{
	  tmp=&buf[4];
/* 	  printf (": '%s'\n", buf);  */
/*  	  printf ("will parse: '%s'\n", tmp);  */
	  sscanf(tmp, "%d:%d", &pin, &val);
  	  printf ("SET pin:%d val:%d  \n", pin, val);  
	  di_callback(pin,val);
	}

      usleep (1000);
    }
}

static void 
init_proto_impl(void)
{
  set_proto_stream(PROTO_STREAM_DEFAULT); 
  init=1;

  pthread_t p;

  pthread_create(&p, NULL, command_reader, NULL);

}

int 
set_proto_stream(FILE *f)
{
  proto_stream = f;
  return SEARD_COMM_OK;
}



int 
comm_digital_write(uint8_t pin, uint8_t val)
{
  init_proto();
  fprintf(stderr, "pin:%d:%d\n", pin, val); 
  fflush(proto_stream);
  fflush(proto_stream);
  fflush(proto_stream);
  fflush(proto_stream);

  /*
  fprintf(stderr, "                -- Faking dig input in %s\n", __func__); 
  di_callback(pin+1,val+1);
  */
  return SEARD_COMM_OK;
}


void  
comm_setup(void)
{
  PRINT_FUNCTION_NAME((""));
}

int 
comm_register_digin_cb(di_callback_ptr cb)
{
  PRINT_FUNCTION_NAME(("%d",(int)cb));

  if (cb==NULL)
    {
      return SEARD_PROTO_NULL_CALLBACK;
    }

  di_callback = cb;
  return SEARD_PROTO_OK;
}


