/*****
 *                                                                   
 *                   Searduino
 *                      
 *   Copyright (C) 2011 Henrik Sandklef 
 *                                                                   
 * This program is free software; you can redistribute it and/or     
 * modify it under the terms of the GNU General Public License       
 * as published by the Free Software Foundation; either version 3    
 * of the License, or any later version.                             
 *                                                                   
 *                                                                   
 * This program is distributed in the hope that it will be useful,   
 * but WITHOUT ANY WARRANTY; without even the implied warranty of    
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     
 * GNU General Public License for more details.                      
 *                                                                   
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software       
 * Foundation, Inc., 51 Franklin Street, Boston,            
 * MA  02110-1301, USA.                                              
 ****/

#include <Arduino.h>

#ifndef INTERVAL
#define INTERVAL 200
#endif
#define FIRST_LED 0
#define LAST_LED 20

void setup() {
  int i ; 
  for (i=FIRST_LED;i<=LAST_LED;i++)
    {
      pinMode(i, OUTPUT);      
    }
}


int main(void)
{
  char i ;
  char j ;
  double interval;
  char direction = 1;

  init();  
  setup();

  if (INTERVAL!=0)
    {
      interval = INTERVAL;
    }
  else
    {
      interval = 11;
    }
  

  for (;;)
    {
      if (INTERVAL==0)
	{
	  if (interval>1000)
	    {
       	      direction=0;
	    }
	  else if (interval < 10)
	    {
	      direction=1;
	      interval=10;
	    }

	  if (direction!=0)
	    {
	      interval = interval * 1.5;
	    }
	  else
	    {
	      interval = interval / 1.5;
	    }
	}
	  
      for (i=FIRST_LED;i<=LAST_LED;i++)
	digitalWrite(i, 1);

      delay(interval);

      for (i=FIRST_LED;i<=LAST_LED;i++)
	digitalWrite(i, 0);

      delay(interval);
    }
  return 0;
}
